/* C.h */

#define USE_THREAD
/* #define USE_BCC */
/* #define USE_LINUX */
/* #define USE_CENTOS */
/* #define USE_RASPBIAN */
#ifdef USE_CENTOS
#define USE_LINUX
#endif
#ifdef USE_RASPBIAN
#define USE_LINUX
#endif
#ifdef USE_LINUX
#define USE_BCC
#endif
#include <stdio.h> /* printf() */
#include <string.h> /* strcmp(), strlen() */
#include <stdlib.h> /* calloc(), free(), rand() */
#ifndef USE_BCC
/* AKI-H8 3052F USB */
#include "h83048.h"
#define SLEEP_PER_SEC 16000.0
#define NOTUSE_FILES
#else
/* time_t, tm, time(), clock(), CLOCKS_PER_SEC */
#include <time.h>
#ifdef USE_LINUX
#include <termios.h> /* kbhit() */
#include <unistd.h> /* kbhit(), mail, fork() */
#include <fcntl.h> /* kbhit() */
/* mail バークレー・ソケット */
#define _OE_SOCKETS
#include <sys/types.h> /* mail */
#include <sys/socket.h> /* mail */
#include <netinet/in.h> /* mail */
#include <netdb.h> /* mail */
#include <arpa/inet.h> /* mail バークレー・ソケット */
#ifdef USE_CENTOS
#include <mysql.h> /* LINUX CentOS GCC MySQL */
#endif
#ifdef USE_RASPBIAN
#include <mysql/mysql.h> /* LINUX Raspbian GCC MySQL */
#endif
#ifdef USE_RASPBIAN
#include <wiringPi.h> /* LINUX Raspberry Pi 3 Model B I/O */
#endif
#else
#include <conio.h> /* kbhit(), getche() */
#endif
#define SLEEP_PER_SEC 100000000.0
#endif
#ifdef USE_LINUX
#define CLEAR system("clear")
#else
#define CLEAR system("cls")
#endif
#define OK 0
#define NG 1
#define ONE_MORE_TIME 2
#define ON 1
#define OFF 0
