/* EV_Log.h */

#ifndef Panel_h
#define Panel_h
#include "Panel.h"
#endif

#ifndef Timer_h
#define Timer_h
#include "Timer.h"
#endif

#ifndef EV_Time_h
#define EV_Time_h
#include "EV_Time.h"
#endif

#ifndef EV_File_h
#define EV_File_h
#include "EV_File.h"
#endif

/*==================================================================
  L^\\
==================================================================*/
struct EV_Log{
	MYSQL *conn;
	MYSQL_RES *resp;
	MYSQL_ROW row;
	char str_sql1[255];
	char str_sql2[255];
	long mydate;
	long mytime;
	char ch_safety;
	int i_safety;
	char str_limit[9];
	char ch_command;
	char ch_permitcommand;
	char ch_permitturnopen;
	char ch_motor;
	char *p_ch_safety;
	char *p_str_limit;
	char *p_ch_command;
	char *p_ch_permitcommand;
	char *p_ch_permitturnopen;
	char *p_ch_motor;
	struct EV_File SF;
	struct EV_File LF;
	struct EV_File CF;
	struct EV_File PCF;
	struct EV_File PTOF;
	struct EV_File MF;
};

/*==================================================================
  L^\vg^Cv錾
==================================================================*/
void EV_Log(struct EV_Log *This); /* databaseڑ */
void delete_EV_Log(struct EV_Log *This); /* databaseؒf */
void OnLog(struct EV_Log *This, Thread *th); /* databaseL^ */
