/* EV_OpenClose.c */

#include "C.h"
#include "EV_OpenClose.h"

/*==================================================================
  J\֐
==================================================================*/
/*
 * Door
 */
void Door(struct Door *This)
{
	/* l */
	This->m_CLSL = OFF;
	This->m_CLST = OFF;
	This->m_OPSL = OFF;
	This->m_OPST = OFF;
	This->p_CloserSlow = &This->m_CLSL;
	This->p_CloserStop = &This->m_CLST;
	This->p_OpennerSlow = &This->m_OPSL;
	This->p_OpennerStop = &This->m_OPST;
	/* Sleepp */
	This->fstop = OFF;
	This->p_fstop = &This->fstop;
	This->fmove = OFF;
	This->p_fmove = &This->fmove;
	
	/* ߂ */
	return;
}

/*
 * OpenMotor
 */
void OpenMotor(struct OpenMotor *This)
{
	EV_File(&This->SF);
	EV_File(&This->MF);
	
	/* ߂ */
	return;
}

/*
 * OnOpenMotor
 */
/* J */
void OnOpenMotor(struct OpenMotor *This, struct Door *DR, char *p_Safety)
{
	if(*DR->p_OpennerStop == ON){
		/* Sleepp */
		if(*DR->p_fstop == OFF){
			*DR->p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 's');
			PrintF(ClsPnl, "STOP");
		}
		if(*p_Safety == 'Y'){
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*DR->p_OpennerSlow == ON){
		/* Sleepp */
		*DR->p_fstop = OFF;
		if(*DR->p_fmove == OFF){
			*DR->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'o');
			PrintF(ClsPnl, "OPEN");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 'h');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*DR->p_CloserSlow == OFF){
		/* Sleepp */
		*DR->p_fstop = OFF;
		if(*DR->p_fmove == OFF){
			*DR->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'O');
			PrintF(ClsPnl, "OPEN Speedy");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 'h');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*DR->p_CloserStop == OFF){
		/* Sleepp */
		*DR->p_fstop = OFF;
		if(*DR->p_fmove == OFF){
			*DR->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'o');
			PrintF(ClsPnl, "OPEN");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 'h');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*DR->p_CloserStop == ON){
		/* Sleepp */
		*DR->p_fstop = OFF;
		if(*DR->p_fmove == OFF){
			*DR->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'h');
			PrintF(ClsPnl, "OPEN Start");
		}
		if(*p_Safety == 'Y'){
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	
	/* ߂ */
	return;
}

/*
 * CloseMotor
 */
void CloseMotor(struct CloseMotor *This)
{
	EV_File(&This->SF);
	EV_File(&This->MF);
	
	/* ߂ */
	return;
}

/*
 * OnCloseMotor
 */
/*  */
void OnCloseMotor(struct CloseMotor *This, struct Door *DR, char *p_Safety)
{
	if(*DR->p_CloserStop == ON){
		/* Sleepp */
		if(*DR->p_fstop == OFF){
			*DR->p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 's');
			PrintF(ClsPnl, "STOP");
		}
		if(*p_Safety == 'Y'){
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*DR->p_CloserSlow == ON){
		/* Sleepp */
		*DR->p_fstop = OFF;
		if(*DR->p_fmove == OFF){
			*DR->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'c');
			PrintF(ClsPnl, "CLOSE");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 't');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*DR->p_OpennerSlow == OFF){
		/* Sleepp */
		*DR->p_fstop = OFF;
		if(*DR->p_fmove == OFF){
			*DR->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'C');
			PrintF(ClsPnl, "CLOSE Speedy");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 't');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*DR->p_OpennerStop == OFF){
		/* Sleepp */
		*DR->p_fstop = OFF;
		if(*DR->p_fmove == OFF){
			*DR->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'c');
			PrintF(ClsPnl, "CLOSE");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 't');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*DR->p_OpennerStop == ON){
		/* Sleepp */
		*DR->p_fstop = OFF;
		if(*DR->p_fmove == OFF){
			*DR->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 't');
			PrintF(ClsPnl, "CLOSE Start");
		}
		if(*p_Safety == 'Y'){
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	
	/* ߂ */
	return;
}

/*
 * WaitDoorChangeLog
 */
/* Gx[^[̈ʒuzO */
void WaitDoorChangeLog(struct WaitDoorChangeLog *This)
{
	This->p_chTurnOpen = &This->chTurnOpen;
	This->p_strLimit = &This->strLimit[0];
	
	/* ߂ */
	return;
}

/*
 * OnInitWaitDoorChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnInitWaitDoorChangeLog(struct WaitDoorChangeLog *This, struct Door *DR)
{
	/* ZTl */
	/* ~bgXCb`̓ǂݍ */
	This->p_strLimit = &This->strLimit[0];
	Limit_Read(&This->LF, This->p_strLimit);
	This->tmp = (This->strLimit[4] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserStop, DR->p_fmove, This->tmp);
	This->tmp = (This->strLimit[5] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserSlow, DR->p_fmove, This->tmp);
	This->tmp = (This->strLimit[6] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerSlow, DR->p_fmove, This->tmp);
	This->tmp = (This->strLimit[7] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerStop, DR->p_fmove, This->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitOpenDoorChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnWaitOpenDoorChangeLog(struct WaitDoorChangeLog *This, struct Door *DR)
{
	/* ~bgXCb`̓ǂݍ */
	This->p_strLimit = &This->strLimit[0];
	Limit_Read(&This->LF, This->p_strLimit);
	This->tmp = (This->strLimit[4] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserStop, DR->p_fmove, This->tmp);
	This->tmp = (This->strLimit[5] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserSlow, DR->p_fmove, This->tmp);
	This->tmp = (This->strLimit[6] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerSlow, DR->p_fmove, This->tmp);
	This->tmp = (This->strLimit[7] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerStop, DR->p_fmove, This->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitCloseDoorChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnWaitCloseDoorChangeLog(struct WaitDoorChangeLog *This, struct Door *DR)
{
	/* ~bgXCb`̓ǂݍ */
	This->p_strLimit = &This->strLimit[0];
	Limit_Read(&This->LF, This->p_strLimit);
	This->tmp = (This->strLimit[4] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserStop, DR->p_fmove, This->tmp);
	This->tmp = (This->strLimit[5] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserSlow, DR->p_fmove, This->tmp);
	This->tmp = (This->strLimit[6] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerSlow, DR->p_fmove, This->tmp);
	This->tmp = (This->strLimit[7] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerStop, DR->p_fmove, This->tmp);
	
	/* ߂ */
	return;
}

/*
 * Open
 */
/* J */
void Open(struct Door *DR, struct OpenMotor OPMT, struct WaitDoorChangeLog WDCL, char *p_Safety)
{
	/* ܂ */
	if(*DR->p_OpennerStop == OFF)
	{
		/* Gx[^[̈ʒuzO */
		OnWaitOpenDoorChangeLog(&WDCL, DR);
		
		/* J */
		OnOpenMotor(&OPMT, DR, p_Safety);
		
		/* Gx[^[̈ʒuzO */
		OnWaitOpenDoorChangeLog(&WDCL, DR);
	}
	
	/* ߂ */
	return;
}

/*
 * Close
 */
/*  */
void Close(struct Door *DR, struct CloseMotor CLMT, struct WaitDoorChangeLog WDCL, char *p_Safety)
{
	/* ܂ */
	if(*DR->p_CloserStop == OFF)
	{	
		/* Gx[^[̈ʒuzO */
		OnWaitCloseDoorChangeLog(&WDCL, DR);
		
		/*  */
		OnCloseMotor(&CLMT, DR, p_Safety);
		
		/* Gx[^[̈ʒuzO */
		OnWaitCloseDoorChangeLog(&WDCL, DR);
	}

	/* ߂ */
	return;
}
