/* EV_Puls.h */

#ifndef Panel_h
#define Panel_h
#include "Panel.h"
#endif

#ifndef Timer_h
#define Timer_h
#include "Timer.h"
#endif

#ifndef EV_Time_h
#define EV_Time_h
#include "EV_Time.h"
#endif

#ifndef EV_File_h
#define EV_File_h
#include "EV_File.h"
#endif

/* Raspberry Pi 3 Model B I/O */
#ifdef USE_RASPBIAN
#define GPIO16 16
#define GPIO17 17
#define GPIO18 18
#define GPIO19 19
#define GPIO20 20
#endif

/*==================================================================
  M\\
==================================================================*/
struct EV_Puls
{
	char ch;
	char *p_ch;
	char Command;
	char *p_Command;
	/* t@CXg[ */
	struct EV_File CF;
	struct EV_File MF;
};

/*==================================================================
  M\֐̃vg^Cv錾
==================================================================*/
void EV_Set(int addressDataSet, int dataSet, int addressClockSet,
 int clockSet);
void EV_EnableSet(void);
int EV_AddressSet(Thread *th, int base, int address);
int EV_DataSet(Thread *th, int base, int data);
void EV_AddressDataSet(struct EV_Puls *puls, Thread *th,
 int address_1, int address_2, int address_3, int address_4,
 int data_1, int data_2, int data_3, int data_4);

/*==================================================================
  M\RXgN^ƃ\bh̃vg^Cv錾
==================================================================*/
void EV_Puls(struct EV_Puls *This, Thread *th);
void OnPuls(struct EV_Puls *This, Thread *th);
