/* EV_Simulator.c */

#include "C.h"
#include "EV_Simulator.h"

/*==================================================================
  V~[^֐
==================================================================*/
void EV_Simulator(struct EV_Simulator *This, Thread *th)
{
	/*  */
	EV_Time(&This->T, th);
	SetCurrentTime(&This->T);
	This->p_ch = &This->ch;
	This->p_ch2 = &This->ch2;
	This->p_ch3 = &This->ch3;
	This->p_str = &This->str[0];
	This->str[8] = '\0';
	EV_File(&This->SF);
	EV_File(&This->CF);
	EV_File(&This->MF);
	EV_File(&This->LF);
	
	/* [^[߉ */
	if(Read(&This->MF, "Motor.txt\0", This->p_ch) == NG) return;
	/* ~bgXCb`̑Oԓǂݍ */
	if(ReadString(&This->LF, "Limit.txt\0", This->p_str, 9) == NG) return;
	/* ĕ\ */
	Disp(This->ch, This->str);
}

void OnSimulator(struct EV_Simulator *This, Thread *th)
{
	/* I */
	Read(&This->CF, "Command.txt\0", This->p_ch3);
	if(This->ch3 == 'q'){
		Clear();
		delete_(th);
		return;
	}
	
	/* [^[߉ */
	Read(&This->MF, "Motor.txt\0", This->p_ch);
	
	/* ~bgXCb`̑Oԓǂݍ */
	ReadString(&This->LF, "Limit.txt\0", This->p_str, 9);
	
	/* ~ */
	Read(&This->SF, "Safety.txt\0", This->p_ch2);
	if(This->ch2 == 's'){
		Write(&This->CF, "Command.txt\0", 'N');
		/* ĕ\ */
		Disp(This->ch, This->str);
		return;
	}
	
	/* ~bgXCb`̐Vԍ쐬 */
	if(This->ch == 'u'){
		if(This->str[0] == 'y');
		else if(This->str[1] == 'y') This->str[1] = 'n';
		else if(This->str[2] == 'n');
		else if(This->str[3] == 'n') This->str[3] = 'y';
	}
	else if(This->ch == 'U'){
		if(This->str[0] == 'y');
		else if(This->str[1] == 'y');
		else if(This->str[2] == 'n') This->str[2] = 'y';
		else if(This->str[3] == 'n');
	}
	else if(This->ch == 'j'){
		if(This->str[0] == 'y') This->str[0] = 'n';
		else if(This->str[1] == 'y') This->str[1] = 'n';
		else if(This->str[2] == 'n') This->str[2] = 'y';
		else if(This->str[3] == 'n') This->str[3] = 'y';
	}
	else if(This->ch == 'd'){
		if(This->str[3] == 'y');
		else if(This->str[2] == 'y') This->str[2] = 'n';
		else if(This->str[1] == 'n');
		else if(This->str[0] == 'n') This->str[0] = 'y';
	}
	else if(This->ch == 'D'){
		if(This->str[3] == 'y');
		else if(This->str[2] == 'y');
		else if(This->str[1] == 'n') This->str[1] = 'y';
		else if(This->str[0] == 'n');
	}
	else if(This->ch == 'k'){
		if(This->str[3] == 'y') This->str[3] = 'n';
		else if(This->str[2] == 'y') This->str[2] = 'n';
		else if(This->str[1] == 'n') This->str[1] = 'y';
		else if(This->str[0] == 'n') This->str[0] = 'y';
	}
	else if(This->ch == 'o'){
		if(This->str[4] == 'y');
		else if(This->str[5] == 'y') This->str[5] = 'n';
		else if(This->str[6] == 'n');
		else if(This->str[7] == 'n') This->str[7] = 'y';
	}
	else if(This->ch == 'O'){
		if(This->str[4] == 'y');
		else if(This->str[5] == 'y');
		else if(This->str[6] == 'n') This->str[6] = 'y';
		else if(This->str[7] == 'n');
	}
	else if(This->ch == 'h'){
		if(This->str[4] == 'y') This->str[4] = 'n';
		else if(This->str[5] == 'y') This->str[5] = 'n';
		else if(This->str[6] == 'n') This->str[6] = 'y';
		else if(This->str[7] == 'n') This->str[7] = 'y';
	}
	else if(This->ch == 'c'){
		if(This->str[7] == 'y');
		else if(This->str[6] == 'y') This->str[6] = 'n';
		else if(This->str[5] == 'n');
		else if(This->str[4] == 'n') This->str[4] = 'y';
	}
	else if(This->ch == 'C'){
		if(This->str[7] == 'y');
		else if(This->str[6] == 'y');
		else if(This->str[5] == 'n') This->str[5] = 'y';
		else if(This->str[4] == 'n');
	}
	else if(This->ch == 't'){
		if(This->str[7] == 'y') This->str[7] = 'n';
		else if(This->str[6] == 'y') This->str[6] = 'n';
		else if(This->str[5] == 'n') This->str[5] = 'y';
		else if(This->str[4] == 'n') This->str[4] = 'y';
	}
	
	/* ~bgXCb`̐Vԏ */
	WriteString(&This->LF, "Limit.txt\0", This->str);
	
	/* ĕ\ */
	Disp(This->ch, This->str);
	
	return;
}
