#!/bin/bash
cd `dirname $0`
find $PWD -name RaspberryPi3ModelBBuild.bash
rm ./RaspberryPi3ModelBError.txt
gcc -D"USE_RASPBIAN" -Wall -o RaspberryPi3ModelBExe.out main.c EV_Log.c EV_Simulator.c EV_Puls.c EV_Controller.c EV_Input.c EV_Display.c EV_OpenClose.c EV_UpDown.c EV_File.c EV_Time.c Timer.c Panel.c -I/usr/local/include -L/usr/local/lib -lwiringPi -lmariadbclient &>>./RaspberryPi3ModelBError.txt
exit
