/* Timer.c */

#include "C.h"
#include "Timer.h"

/* Ԃ\Oϐ錾 */
double woviClock;

/* ^Xbh` */
#ifdef USE_THREAD
/* wovip^CX^X錾 */
Thread woviThreadFirst;
Thread woviThreadLast;
#endif

/* 擾 */
double getClock(void)
{
	return woviClock;
}

/* ~b҂֐ */
void SleepMSec(long ms)
{
#ifndef USE_BCC
	double start;
	double set;
	double end;
	start = getClock();
	set = ((double) ms) / 1000;
	end = start;
	while(end < start + set)
	{
		end = getClock();
	}
#else
	double cnt;
	double set;
	cnt = 0.0;
	set = ((double) ms) / 1000;
	while(cnt < set)
	{
		cnt += 1.0 / SLEEP_PER_SEC;
	}
#endif
	return;
}

#ifdef USE_THREAD
/* Xbhvoid Sleep(int ms)̑p */
void nextRun(Thread *This, long ms)
{
	This->preClock = getClock();
	This->setClock = (((double) ms) / 1000);
	return;
}

/* Xbhvoid Sleep(int ms)̑p */
void countUpNextRun(Thread *This, long ms)
{
	nextRun(This, ms);
	This->count++;
}

#ifndef USE_BCC
Thread th101;
Thread th102;
Thread th111;
Thread th112;
Thread th113;
Thread th114;
Thread th119;
Thread th120;
Thread th121;
Thread th122;
Thread th123;
Thread th130;
Thread th131;
Thread th141;
Thread th142;
Thread th143;
Thread th144;
Thread th145;
#endif

/* Xbh̃RXgN^̑p */
Thread *new_Thread(int id)
{
	Thread *List;
	Thread *new_List;
	List = &woviThreadFirst;
	while(List->next->next != NULL)
	{
		List = List->next;
	}
#ifndef USE_BCC
	if(id == 1)
	{
		new_List = &th101;
	}
	else if(id == 2)
	{
		new_List = &th102;
	}
	else if(id == 11)
	{
		new_List = &th111;
	}
	else if(id == 12)
	{
		new_List = &th112;
	}
	else if(id == 13)
	{
		new_List = &th113;
	}
	else if(id == 14)
	{
		new_List = &th114;
	}
	else if(id == 19)
	{
		new_List = &th119;
	}
	else if(id == 20)
	{
		new_List = &th120;
	}
	else if(id == 21)
	{
		new_List = &th121;
	}
	else if(id == 22)
	{
		new_List = &th122;
	}
	else if(id == 23)
	{
		new_List = &th123;
	}
	else if(id == 30)
	{
		new_List = &th130;
	}
	else if(id == 31)
	{
		new_List = &th131;
	}
	else if(id == 41)
	{
		new_List = &th141;
	}
	else if(id == 42)
	{
		new_List = &th142;
	}
	else if(id == 43)
	{
		new_List = &th143;
	}
	else if(id == 44)
	{
		new_List = &th144;
	}
	else if(id == 45)
	{
		new_List = &th145;
	}
#endif
#ifdef USE_BCC
	new_List = (Thread *)calloc(1, sizeof(Thread));
#endif
	if(new_List == NULL)
	{
		PrintF(Panel, "\n");
		PrintF(Panel, "calloc failed");
		return NULL;
	}
	new_List->previous = List;
	new_List->next = List->next;
	new_List->next->previous = new_List;
	List->next = new_List;
	new_List->preClock = INITCLOCKNO;
	new_List->setClock = 0;
	new_List->ID = id;
	new_List->count = 0;
	/* Xbhvoid init(void)̑p */
	Init(new_List);
	return new_List;
}

/* Xbh̃fXgN^̑p */
void delete_(Thread *This)
{
	Destroy(This);
	This->previous->next = This->next;
	This->next->previous = This->previous;
#ifdef USE_BCC
	free(This);
#endif
	return;
}

/* Xbhvoid start(void)̑p */
void Start(Thread *This)
{
	woviClock = getClock();
	This->preClock = woviClock;
	return;
}

/* Xbhvoid stop(void)̑p */
void Stop(Thread *This)
{
	This->preClock = STOPCLOCKNO;
	return;
}

int Thread_checkAllDelete(void)
{
	if(woviThreadFirst.next->next == NULL)
	{
		return OK;
	}
	else
	{
		return NG;
	}
}

int Thread_checkStayAnother(void)
{
	Thread *checkthread = woviThreadFirst.next->next;
	int i = 0;
	while(checkthread != NULL)
	{
		checkthread = checkthread->next;
		i = i + 1;
	}
	return i;
}

Thread *Thread_getThread(int id)
{
	Thread *th;
	
	if(woviThreadFirst.next->next == NULL)
	{
		return NULL;
	}
	else
	{
		th = woviThreadFirst.next;
		do
		{
			if(th->ID == id)
			{
				return th;
			}
			else
			{
				th = th->next;
			}
		}while(th->next != NULL);
	}
	return NULL;
}

Thread *Thread_Start(int id)
{
	Thread *th;
	
	th = Thread_getThread(id);
	if(th == NULL)
	{
		 th = new_Thread(id);
		 Start(th);
	}
	else if(th->preClock == STOPCLOCKNO)
	{
		Start(th);
	}
	return th;
}

void Thread_Toggle(int id)
{
	Thread *th;
	
	th = Thread_getThread(id);
	if(th == NULL)
	{
		 th = new_Thread(id);
		 Start(th);
	}
	else if(th->preClock == STOPCLOCKNO)
	{
		Start(th);
	}
	else
	{
		delete_(th);
	}
	return;
}

/* ^C}֐ */
/* RunĂԃ^C~O */
void woviRun(void)
{
	Thread *List;
	Thread *next_List;
	List = &woviThreadFirst;
	List = List->next;
	while(List->next != NULL)
	{
		next_List = List->next;
		if((List->preClock != INITCLOCKNO) && (List->preClock != STOPCLOCKNO))
		{
			if(woviClock >= List->preClock + List->setClock)
			{
				List->preClock = woviClock;
				/* Xbhvoid run(void)̑p */
				Run(List);
			}
		}
		List = next_List;
	}
	return;
}

/* ^C}֐ */
/* ֐main ̖`ŁA */
/* Xbh\̃Xg  [ ܂B */
void woviInit(void)
{
	woviThreadFirst.previous = NULL;
	woviThreadFirst.next = &woviThreadLast;
	woviThreadLast.previous = &woviThreadFirst;
	woviThreadLast.next = NULL;
	return;
}

#ifndef USE_BCC
/* ^C}荞ݗp */
/* ֐main ̖`ŁA */
/* ^C}荞 ̐pݒāA */
/* ^C}0荞 𗧂グ܂B */
void InitITU(void)
{
	ITU.TSTR = 0x01; /* timer 0 enable */
	ITU.TSNC = 0;
	ITU.TMDR = 0x0;
	ITU.TFCR = 0x0;
	ITU.TOER = 0x0;
	ITU.TOCR = 0xff;
	ITU0.TCR = 0x00; /* Ȃ */
	ITU0.TIOR = 0x88;
	ITU0.TIER = 0x04; /*@I[o[t[荞݋@*/
	/* AKI-H8 3052F USB ̉Zx 25MHz Ȃ̂ŁA */
	/* 25KJEg ƁA 1ms łB */
	ITU0.TCNT = 0xffff - 25000; /* 1 msec interval */
	ITU0.GRA = 0;
	ITU0.GRB = 0;
}

/* ^C}荞ݗp */
/* ̊֐ ֐main ĂяoĂ̂ɁA */
/* ̊֐́A asmfile.src  ^C}0荞  */
/* ڌĂяoĂ܂B */
void InterruptITU0(void)
{
	ITU0.TSR &= 0xfb;
	/* AKI-H8 3052F USB ̉Zx 25MHz Ȃ̂ŁA */
	/* 25KJEg ƁA 1ms łB */
	ITU0.TCNT = 0xffff - 25000; /* 1 msec interval */
	/* woviClock ̓VXeZbg̕bvłB */
	woviClock += 0.001;
	return;
}
#endif

/* ^C}֐ */
#ifdef USE_LINUX
void wovi(double threadPerSec)
#else
void wovi(void)
#endif
{
#ifdef USE_BCC
	/* woviClock ͕bv */
#ifdef USE_LINUX
	/* threadPerSec Ŏ󂯎鐔l1ɋ߂ÂA */
	/* Xs[hオ܂B */
	/* threadPerSec Ŏ󂯎鐔l傫ȂA */
	/* Xs[h܂B */
	/* ^C}荞 gpłȂ */
	/* threadPerSec gp܂B */
	woviClock += 1.0 / threadPerSec;
#else
	/* ́A <time.h>  clock() gp܂B */
	woviClock = (double) (clock() / CLOCKS_PER_SEC);
#endif
#endif
	woviRun(); /* Xbĥ߂RunĂԃ^C~O */
	return;
}

/* ^C}֐ */
void initWOVI(void)
{
	/* ֐main ̖`ŁA */
	/* bvwoviClock  */
	/* 0.0b ŏ܂B */
	woviClock = 0.0;
	/* ^C}荞ݗp */
#ifndef USE_BCC
	/* ^C}0荞 𗧂グ܂B */
	InitITU();
	/* asmfile.src  荞݋x Ăт܂B */
	EnableInterrupt();
#endif
	/* Xbh\̃Xg  [ ܂B */
	woviInit();
	return;
}
#endif

#ifdef USE_BCC
/* ݓ\ */
void PrintCurrentTime(void)
{
	time_t timer;
	struct tm *t_st;
	
	/* ݎ̎擾 */
	time(&timer);
	
	/* ݎ\̂ɕϊ */
	t_st = localtime(&timer);
	
	printf("%d", t_st->tm_year+1900);
	if(t_st->tm_mon+1 < 10)
	{
		printf("0%d", t_st->tm_mon+1);
	}
	else
	{
		printf("%d", t_st->tm_mon+1);
	}
	if(t_st->tm_mday < 10)
	{
		printf("0%d", t_st->tm_mday);
	}
	else
	{
		printf("%d", t_st->tm_mday);
	}
	printf(" ");
	if(t_st->tm_hour < 10)
	{
		printf("0%d", t_st->tm_hour);
	}
	else
	{
		printf("%d", t_st->tm_hour);
	}
	if(t_st->tm_min < 10)
	{
		printf("0%d", t_st->tm_min);
	}
	else
	{
		printf("%d", t_st->tm_min);
	}
	if(t_st->tm_sec < 10)
	{
		printf("0%d", t_st->tm_sec);
	}
	else
	{
		printf("%d", t_st->tm_sec);
	}
	
	return;
}
void myDateTime(long *mydate, long *mytime)
{
	time_t timer;
	struct tm *t_st;
	
	/* ݎ̎擾 */
	time(&timer);
	
	/* ݎ\̂ɕϊ */
	t_st = localtime(&timer);
	
	*mydate = t_st->tm_year + 1900;
	*mydate *= 100;
	*mydate += (t_st->tm_mon + 1);
	*mydate *= 100;
	*mydate += t_st->tm_mday;
	
	*mytime = t_st->tm_hour;
	*mytime *= 100;
	*mytime += t_st->tm_min;
	*mytime *= 100;
	*mytime += t_st->tm_sec;
	
	return;
}
#endif
