/* EV_Controller.h */

#ifndef Panel_h
#define Panel_h
#include "Panel.h"
#endif

#ifndef Timer_h
#define Timer_h
#include "Timer.h"
#endif

#ifndef EV_Time_h
#define EV_Time_h
#include "EV_Time.h"
#endif

#ifndef EV_File_h
#define EV_File_h
#include "EV_File.h"
#endif

#ifndef EV_UpDown_h
#define EV_UpDown_h
#include "EV_UpDown.h"
#endif

#ifndef EV_OpenClose_h
#define EV_OpenClose_h
#include "EV_OpenClose.h"
#endif

/*==================================================================
  Ղ\\̐錾
==================================================================*/
struct EV_Controller
{
	/* Gx[^[݈̌ʒuIuWFNg̐錾 */
	struct Position P;
	struct Position *p_P;

	/* ㏸IuWFNg̐錾 */
	struct UpMotor UPMT;
	/* ~IuWFNg̐錾 */
	struct DownMotor DNMT;

	/* Gx[^[̈ʒuzO */
	struct WaitPositionChangeLog WPCL;

	/* Gx[^[݈̌ʒuIuWFNg̐錾 */
	struct Door DR;
	struct Door *p_DR;

	/* JIuWFNg̐錾 */
	struct OpenMotor OPMT;
	/* IuWFNg̐錾 */
	struct CloseMotor CLMT;

	/* Gx[^[̈ʒuzO */
	struct WaitDoorChangeLog WDCL;

	/* oߎԃe| */
	struct EV_Time T;
	
	/* S */
	char Safety;
	char *p_Safety;
	/* Limit */
	char str[9];
	char *p_str;
	/*  */
	char Command;
	char *p_Command;
	char PermitCommand;
	char *p_PermitCommand;
	char PermitTurnOpen;
	char *p_PermitTurnOpen;

	/* t@CXg[ */
	struct EV_File SF;
	struct EV_File LF;
	struct EV_File CF;
	struct EV_File PCF;
	struct EV_File PTOF;
	struct EV_File MF;
};

/*==================================================================
  \RXgN^ƃ\bh̃vg^Cv錾
==================================================================*/
void EV_Controller(struct EV_Controller *This, Thread *th);
void OnController(struct EV_Controller *This, Thread *th);
