/* EV_Input.c */

#include "C.h"
#include "EV_Input.h"

/*==================================================================
  ͂\֐
==================================================================*/
char GetChar(char Ret)
{
#ifndef USE_BCC
	char sw[4];
	int i;
	int j;
	/* XCb`[N */
	sw[0] = sw[1] = sw[2] = sw[3] = 0;
	/* {^ꂽLCD,SCI,USBɃbZ[W𑗂 */
	for(j=0;j<4;j++)
	{
		i = GetSW(j);
		if( ((sw[j]^1) & i) ) /* sw = off->onŏ */
		{
			switch(j){
			case 0:
				Ret = 'u'; /* sw0 Up 2KŊJ */
				break;
			case 1:
				Ret = 'd'; /* sw1 Down 1KŊJ */
				break;
			case 2:
				Ret = 'c'; /* sw2 Close  */
				break;
			case 3:
				Ret = 'q'; /* sw3 Quit I */
				break;
			default:
				break;
			}
		}
	}
#else
#ifdef USE_LINUX
	if(kbhit())
	{
		Ret = (char) getchar();
	}
#else
#ifdef USE_MSVS2005
	if(_kbhit())
	{
		Ret = (char) _getche();
	}
#else
	if(kbhit())
	{
		Ret = (char) getche();
	}
#endif
#endif
#endif
	return Ret;
}

/*==================================================================
  ͂\RXgN^ƃ\bh
==================================================================*/
void EV_Input(struct EV_Input *This)
{
	/*  */
	This->Command = '\0';
	This->p_ch = &This->ch;
	This->p_str = &This->str[0];
	This->str[8] = '\0';
	/* S */
	This->p_Safety = &This->Safety;
	/* ͋ */
	This->p_PermitCommand = &This->PermitCommand;
	/* ]J */
	This->p_PermitTurnOpen = &This->PermitTurnOpen;
	
	EV_File(&This->SF);
	EV_File(&This->CF);
	EV_File(&This->PCF);
	EV_File(&This->PTOF);
	EV_File(&This->MF);

	/* S */
	if(Read(&This->SF, "Safety.txt\0", This->p_Safety) == NG) return;
	/* ͋ */
	if(PermitCommand_Read(&This->PCF, This->p_PermitCommand) == NG) return;
	/* ]J */
	if(PermitTurnOpen_Read(&This->PTOF, This->p_PermitTurnOpen) == NG) return;
	/* [^[߉ */
	if(Read(&This->MF, "Motor.txt\0", This->p_ch) == NG) return;
	/* ~bgXCb`̑Oԓǂݍ */
	ReadString(&This->LF, "Limit.txt\0", This->p_str, 9);
}

void OnInput(struct EV_Input *This, Thread *th)
{
	if(Command_Read(&This->CF, &This->Command) == NG) return;
	This->Command = GetChar(This->Command);
	
	/* S */
	if(Read(&This->SF, "Safety.txt\0", This->p_Safety) == NG) return;
	/* ͋ */
	if(PermitCommand_Read(&This->PCF, This->p_PermitCommand) == NG) return;
	/* ]J */
	if(PermitTurnOpen_Read(&This->PTOF, This->p_PermitTurnOpen) == NG) return;
	/* [^[߉ */
	if(Read(&This->MF, "Motor.txt\0", This->p_ch) == NG) return;
	/* ~bgXCb`̑Oԓǂݍ */
	ReadString(&This->LF, "Limit.txt\0", This->p_str, 9);
	
	switch(This->Command){
	case 's':
		/* ߓ */
		Write(&This->SF, "Safety.txt", 's');
		Motor_Write(&This->MF, 's');
		This->Command = 'N';
		Command_Write(&This->CF, 'N');
		PermitCommand_Write(&This->PCF, 'N');
		break;
	case 'r':
		/* ߓ */
		Write(&This->SF, "Safety.txt", 'h');
		This->Command = 'N';
		Command_Write(&This->CF, 'N');
		PermitCommand_Write(&This->PCF, 'c');
		break;
	case 'q':
		/* ߓ */
		Command_Write(&This->CF, This->Command);
		PrintF(ClsPnl, "QUIT");
		delete_(th);
		break;
	default:
		if(This->PermitCommand == 'c'){
			switch(This->Command){
			case 'o':
				if(This->str[4] != 'y'){
					PermitTurnOpen_Write(&This->PTOF, 'o');
				}
				if(This->Safety == 'h'){
					/* ߓ */
					This->Safety = 'Y';
					Write(&This->SF, "Safety.txt", 'Y');
					if((This->ch == 's') && (This->Safety == 'Y') && (This->str[7] == 'n')){
						Motor_Write(&This->MF, 'h');
					}
				}
				/* ߓ */
				Command_Write(&This->CF, This->Command);
				PermitCommand_Write(&This->PCF, 'N');
				break;
			case 'c':
				if(This->str[4] != 'y'){
					PermitTurnOpen_Write(&This->PTOF, 'o');
				}
				if(This->Safety == 'h'){
					/* ߓ */
					This->Safety = 'Y';
					Write(&This->SF, "Safety.txt", 'Y');
					if((This->ch == 's') && (This->Safety == 'Y') && (This->str[4] == 'n')){
						Motor_Write(&This->MF, 't');
					}
				}
				/* ߓ */
				Command_Write(&This->CF, This->Command);
				PermitCommand_Write(&This->PCF, 'N');
				break;
			case 'u':
				if(This->str[4] != 'y'){
					PermitTurnOpen_Write(&This->PTOF, 'o');
				}
				if(This->Safety == 'h'){
					/* ߓ */
					This->Safety = 'Y';
					Write(&This->SF, "Safety.txt", 'Y');
					if((This->ch == 's') && (This->Safety == 'Y') && (This->str[0] == 'y') && (This->str[4] == 'n')){
						Motor_Write(&This->MF, 't');
					}
					else if((This->ch == 's') && (This->Safety == 'Y') && (This->str[3] == 'n')){
						Motor_Write(&This->MF, 'j');
					}
					else if((This->ch == 's') && (This->Safety == 'Y') && (This->str[3] == 'y') && (This->str[7] == 'n')){
						Motor_Write(&This->MF, 'h');
					}
				}
				/* ߓ */
				Command_Write(&This->CF, This->Command);
				PermitCommand_Write(&This->PCF, 'N');
				break;
			case 'd':
				if(This->str[4] != 'y'){
					PermitTurnOpen_Write(&This->PTOF, 'o');
				}
				if(This->Safety == 'h'){
					/* ߓ */
					This->Safety = 'Y';
					Write(&This->SF, "Safety.txt", 'Y');
					if((This->ch == 's') && (This->Safety == 'Y') && (This->str[3] == 'y') && (This->str[4] == 'n')){
						Motor_Write(&This->MF, 't');
					}
					else if((This->ch == 's') && (This->Safety == 'Y') && (This->str[0] == 'n')){
						Motor_Write(&This->MF, 'k');
					}
					else if((This->ch == 's') && (This->Safety == 'Y') && (This->str[0] == 'y') && (This->str[7] == 'n')){
						Motor_Write(&This->MF, 'h');
					}
				}
				/* ߓ */
				Command_Write(&This->CF, This->Command);
				PermitCommand_Write(&This->PCF, 'N');
				break;
			case 'y':
				if((This->str[0] != 'y') && (This->str[4] != 'y')){
					PrintF(Panel, "\nA Basket isn't 1st Floor");
				}
				else{
					if(This->Safety == 'h'){
						/* ߓ */
						This->Safety = 'Y';
						Write(&This->SF, "Safety.txt", 'Y');
						if((This->ch == 's') && (This->Safety == 'Y') && (This->str[0] == 'n')){
							Motor_Write(&This->MF, 'k');
						}
						else if((This->ch == 's') && (This->Safety == 'Y') && (This->str[0] == 'y') && (This->str[7] == 'n')){
							Motor_Write(&This->MF, 'h');
						}
					}
					/* ߓ */
					Command_Write(&This->CF, This->Command);
					PermitCommand_Write(&This->PCF, 'N');
				}
				break;
			case 'Y':
				if((This->str[3] != 'y') && (This->str[4] != 'y')){
					PrintF(Panel, "\nA Basket isn't 2nd Floor");
				}
				else{
					if(This->Safety == 'h'){
						/* ߓ */
						This->Safety = 'Y';
						Write(&This->SF, "Safety.txt", 'Y');
						if((This->ch == 's') && (This->Safety == 'Y') && (This->str[3] == 'n')){
							Motor_Write(&This->MF, 'j');
						}
						else if((This->ch == 's') && (This->Safety == 'Y') && (This->str[3] == 'y') && (This->str[7] == 'n')){
							Motor_Write(&This->MF, 'h');
						}
					}
					/* ߓ */
					Command_Write(&This->CF, This->Command);
					PermitCommand_Write(&This->PCF, 'N');
				}
				break;
			case 'h':
				if(This->str[0] != 'y'){
					PrintF(Panel, "\nA Basket isn't 1st Floor");
				}
				else{
					if(This->str[4] != 'y'){
						PermitTurnOpen_Write(&This->PTOF, 'o');
					}
					if(This->Safety == 'h'){
						/* ߓ */
						This->Safety = 'Y';
						Write(&This->SF, "Safety.txt", 'Y');
						if((This->ch == 's') && (This->Safety == 'Y') && (This->str[4] == 'n')){
							Motor_Write(&This->MF, 't');
						}
					}
					/* ߓ */
					Command_Write(&This->CF, This->Command);
					PermitCommand_Write(&This->PCF, 'N');
				}
				break;
			case 'H':
				if(This->str[3] != 'y'){
					PrintF(Panel, "\nA Basket isn't 2nd Floor");
				}
				else{
					if(This->str[4] != 'y'){
						PermitTurnOpen_Write(&This->PTOF, 'o');
					}
					if(This->Safety == 'h'){
						/* ߓ */
						This->Safety = 'Y';
						Write(&This->SF, "Safety.txt", 'Y');
						if((This->ch == 's') && (This->Safety == 'Y') && (This->str[4] == 'n')){
							Motor_Write(&This->MF, 't');
						}
					}
					/* ߓ */
					Command_Write(&This->CF, This->Command);
					PermitCommand_Write(&This->PCF, 'N');
				}
				break;
			default:
				break;
			}
		}
		else if(This->PermitTurnOpen == 'o'){
			if((This->str[0] == 'y') && (This->str[7] != 'y')){
				switch(This->Command){
				case 'o':
				case 'd':
				case 'y':
					if(This->Safety == 'h'){
						/* ߓ */
						This->Safety = 'Y';
						Write(&This->SF, "Safety.txt", 'Y');
						if((This->ch == 's') && (This->Safety == 'Y') && (This->str[0] == 'y') && (This->str[7] == 'n')){
							Motor_Write(&This->MF, 'h');
						}
					}
					/* ߓ */
					Command_Write(&This->CF, This->Command);
					PermitTurnOpen_Write(&This->PTOF, 'N');
					break;
				default:
					break;
				}
			}
			else if((This->str[3] == 'y') && (This->str[7] != 'y')){
				switch(This->Command){
				case 'o':
				case 'u':
				case 'Y':
					if(This->Safety == 'h'){
						/* ߓ */
						This->Safety = 'Y';
						Write(&This->SF, "Safety.txt", 'Y');
						if((This->ch == 's') && (This->Safety == 'Y') && (This->str[3] == 'y') && (This->str[7] == 'n')){
							Motor_Write(&This->MF, 'h');
						}
					}
					/* ߓ */
					Command_Write(&This->CF, This->Command);
					PermitTurnOpen_Write(&This->PTOF, 'N');
					break;
				default:
					break;
				}
			}
		}
		break;
	}
	return;
}
