/* EV_OpenClose.h */

#ifndef Panel_h
#define Panel_h
#include "Panel.h"
#endif

#ifndef Timer_h
#define Timer_h
#include "Timer.h"
#endif

#ifndef EV_Time_h
#define EV_Time_h
#include "EV_Time.h"
#endif

#ifndef EV_File_h
#define EV_File_h
#include "EV_File.h"
#endif

#ifndef EV_UpDown_h
#define EV_UpDown_h
#include "EV_UpDown.h"
#endif

/*==================================================================
  J\\
==================================================================*/
struct Door
{
	int m_CLSL;
	int m_CLST;
	int m_OPSL;
	int m_OPST;
	/* ʒu */
	int *p_CloserSlow;
	/* ~ʒu */
	int *p_CloserStop;
	/* Jʒu */
	int *p_OpennerSlow;
	/* J~ʒu */
	int *p_OpennerStop;
	/* Sleepp */
	int fstop;
	int *p_fstop;
	int fmove;
	int *p_fmove;
};

/* J */
struct OpenMotor
{
	struct EV_File SF;
	struct EV_File MF;
};

/*  */
struct CloseMotor
{
	struct EV_File	SF;
	struct EV_File	MF;
};

/* Gx[^[̈ʒuzO */
struct WaitDoorChangeLog
{
	struct EV_File TOF;
	char chTurnOpen;
	char *p_chTurnOpen;
	struct EV_File LF;
	char strLimit[9];
	char *p_strLimit;
	/* Sleepp */
	int tmp;
};

/*==================================================================
  J\vg^Cv錾
==================================================================*/
void Door(struct Door *This);
/* J */
void OpenMotor(struct OpenMotor *This);
void OnOpenMotor(struct OpenMotor *This, struct Door *DR, char *p_Safety);
/*  */
void CloseMotor(struct CloseMotor *This);
void OnCloseMotor(struct CloseMotor *This, struct Door *DR, char *p_Safety);
/* oߎ */
void WaitDoorChangeLog(struct WaitDoorChangeLog *This);
void OnInitWaitDoorChangeLog(struct WaitDoorChangeLog *This, struct Door *DR);
void OnWaitOpenDoorChangeLog(struct WaitDoorChangeLog *This, struct Door *DR);
void OnWaitCloseDoorChangeLog(struct WaitDoorChangeLog *This, struct Door *DR);
/* J */
void Open(struct Door *DR, struct OpenMotor OPMT, struct WaitDoorChangeLog WDCL, char *p_Safety);
/*  */
void Close(struct Door *DR, struct CloseMotor CLMT, struct WaitDoorChangeLog WDCL, char *p_Safety);
