/* EV_UpDown.c */

#include "C.h"
#include "EV_UpDown.h"

/*==================================================================
  ㏸~\֐
==================================================================*/
/*
 * Position
 */
void Position(struct Position *This)
{
	/* l */
	This->m_UNSL = OFF;
	This->m_UNST = OFF;
	This->m_UPSL = OFF;
	This->m_UPST = OFF;
	This->p_UnderSlow = &This->m_UNSL;
	This->p_UnderStop = &This->m_UNST;
	This->p_UpperSlow = &This->m_UPSL;
	This->p_UpperStop = &This->m_UPST;
	/* Sleepp */
	This->fstop = OFF;
	This->p_fstop = &This->fstop;
	This->fmove = OFF;
	This->p_fmove = &This->fmove;
	
	/* ߂ */
	return;
}

/*
 * UpMotor
 */
void UpMotor(struct UpMotor *This)
{
	EV_File(&This->SF);
	EV_File(&This->MF);
	
	/* ߂ */
	return;
}

/*
 * OnUpMotor
 */
/* ㏸ */
void OnUpMotor(struct UpMotor *This, struct Position *P, char *p_Safety)
{
	if(*P->p_UpperStop == ON){
		/* Sleepp */
		if(*P->p_fstop == OFF){
			*P->p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 's');
			PrintF(ClsPnl, "STOP");
		}
		if(*p_Safety == 'Y'){
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*P->p_UpperSlow == ON){
		/* Sleepp */
		*P->p_fstop = OFF;
		if(*P->p_fmove == OFF){
			*P->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'u');
			PrintF(ClsPnl, "UP");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 'j');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*P->p_UnderSlow == OFF){
		/* Sleepp */
		*P->p_fstop = OFF;
		if(*P->p_fmove == OFF){
			*P->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'U');
			PrintF(ClsPnl, "UP Speedy");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 'j');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*P->p_UnderStop == OFF){
		/* Sleepp */
		*P->p_fstop = OFF;
		if(*P->p_fmove == OFF){
			*P->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'u');
			PrintF(ClsPnl, "UP");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 'j');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*P->p_UnderStop == ON){
		/* Sleepp */
		*P->p_fstop = OFF;
		if(*P->p_fmove == OFF){
			*P->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'j');
			PrintF(ClsPnl, "UP Start");
		}
		if(*p_Safety == 'Y'){
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	
	/* ߂ */
	return;
}

/*
 * DownMotor
 */
void DownMotor(struct DownMotor *This)
{
	EV_File(&This->SF);
	EV_File(&This->MF);
	
	/* ߂ */
	return;
}

/*
 * OnDownMotor
 */
/* ~ */
void OnDownMotor(struct DownMotor *This, struct Position *P, char *p_Safety)
{
	if(*P->p_UnderStop == ON){
		/* Sleepp */
		if(*P->p_fstop == OFF){
			*P->p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 's');
			PrintF(ClsPnl, "STOP");
		}
		if(*p_Safety == 'Y'){
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*P->p_UnderSlow == ON){
		/* Sleepp */
		*P->p_fstop = OFF;
		if(*P->p_fmove == OFF){
			*P->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'd');
			PrintF(ClsPnl, "DOWN");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 'k');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*P->p_UpperSlow == OFF){
		/* Sleepp */
		*P->p_fstop = OFF;
		if(*P->p_fmove == OFF){
			*P->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'D');
			PrintF(ClsPnl, "DOWN Speedy");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 'k');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*P->p_UpperStop == OFF){
		/* Sleepp */
		*P->p_fstop = OFF;
		if(*P->p_fmove == OFF){
			*P->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'd');
			PrintF(ClsPnl, "DOWN");
		}
		else if(*p_Safety == 'Y'){
			Motor_Write(&This->MF, 'k');
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	else if(*P->p_UpperStop == ON){
		/* Sleepp */
		*P->p_fstop = OFF;
		if(*P->p_fmove == OFF){
			*P->p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&This->MF, 'k');
			PrintF(ClsPnl, "DOWN Start");
		}
		if(*p_Safety == 'Y'){
			*p_Safety = 'r';
			Write(&This->SF, "Safety.txt\0", 'r');
		}
	}
	
	/* ߂ */
	return;
}

/*
 * WaitPositionChangeLog
 */
/* Gx[^[̈ʒuzO */
void WaitPositionChangeLog(struct WaitPositionChangeLog *This)
{
	This->p_strLimit = &This->strLimit[0];
	
	/* ߂ */
	return;
}

/*
 * OnInitWaitPositionChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnInitWaitPositionChangeLog(struct WaitPositionChangeLog *This, struct Position *P)
{
	/* ZTl */
	/* ~bgXCb`̓ǂݍ */
	This->p_strLimit = &This->strLimit[0];
	Limit_Read(&This->LF, This->p_strLimit);
	This->tmp = ((This->strLimit[0] == 'y') ? ON : OFF);
	Checkfmove(P->p_UnderStop, P->p_fmove, This->tmp);
	This->tmp = ((This->strLimit[1] == 'y') ? ON : OFF);
	Checkfmove(P->p_UnderSlow, P->p_fmove, This->tmp);
	This->tmp = ((This->strLimit[2] == 'y') ? ON : OFF);
	Checkfmove(P->p_UpperSlow, P->p_fmove, This->tmp);
	This->tmp = ((This->strLimit[3] == 'y') ? ON : OFF);
	Checkfmove(P->p_UpperStop, P->p_fmove, This->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitUpPositionChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnWaitUpPositionChangeLog(struct WaitPositionChangeLog *This, struct Position *P)
{
	/* ~bgXCb`̓ǂݍ */
	This->p_strLimit = &This->strLimit[0];
	Limit_Read(&This->LF, This->p_strLimit);
	This->tmp = (This->strLimit[0] == 'y') ? ON : OFF;
	Checkfmove(P->p_UnderStop, P->p_fmove, This->tmp);
	This->tmp = (This->strLimit[1] == 'y') ? ON : OFF;
	Checkfmove(P->p_UnderSlow, P->p_fmove, This->tmp);
	This->tmp = (This->strLimit[2] == 'y') ? ON : OFF;
	Checkfmove(P->p_UpperSlow, P->p_fmove, This->tmp);
	This->tmp = (This->strLimit[3] == 'y') ? ON : OFF;
	Checkfmove(P->p_UpperStop, P->p_fmove, This->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitDownPositionChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnWaitDownPositionChangeLog(struct WaitPositionChangeLog *This, struct Position *P)
{
	/* ~bgXCb`̓ǂݍ */
	This->p_strLimit = &This->strLimit[0];
	Limit_Read(&This->LF, This->p_strLimit);
	This->tmp = (This->strLimit[0] == 'y') ? ON : OFF;
	Checkfmove(P->p_UnderStop, P->p_fmove, This->tmp);
	This->tmp = (This->strLimit[1] == 'y') ? ON : OFF;
	Checkfmove(P->p_UnderSlow, P->p_fmove, This->tmp);
	This->tmp = (This->strLimit[2] == 'y') ? ON : OFF;
	Checkfmove(P->p_UpperSlow, P->p_fmove, This->tmp);
	This->tmp = (This->strLimit[3] == 'y') ? ON : OFF;
	Checkfmove(P->p_UpperStop, P->p_fmove, This->tmp);
	
	/* ߂ */
	return;
}

/*
 * Up
 */
/* ㏸ */
void Up(struct Position *P, struct UpMotor UPMT, struct WaitPositionChangeLog WPCL, char *p_Safety)
{
	/* ܂ */
	if(*P->p_UpperStop == OFF){
		/* Gx[^[̈ʒuzO */
		OnWaitUpPositionChangeLog(&WPCL, P);
		
		/* ㏸ */
		OnUpMotor(&UPMT, P, p_Safety);
		
		/* Gx[^[̈ʒuzO */
		OnWaitUpPositionChangeLog(&WPCL, P);
	}
	
	/* ߂ */
	return;
}

/*
 * Down
 */
/* ~ */
void Down(struct Position *P, struct DownMotor DNMT, struct WaitPositionChangeLog WPCL, char *p_Safety)
{
	/* ܂ */
	if(*P->p_UnderStop == OFF){
		/* Gx[^[̈ʒuzO */
		OnWaitDownPositionChangeLog(&WPCL, P);
		
		/* ~ */
		OnDownMotor(&DNMT, P, p_Safety);
		
		/* Gx[^[̈ʒuzO */
		OnWaitDownPositionChangeLog(&WPCL, P);
	}
	
	/* ߂ */
	return;
}
