/* EV_UpDown.h */

#ifndef Panel_h
#define Panel_h
#include "Panel.h"
#endif

#ifndef Timer_h
#define Timer_h
#include "Timer.h"
#endif

#ifndef EV_Time_h
#define EV_Time_h
#include "EV_Time.h"
#endif

#ifndef EV_File_h
#define EV_File_h
#include "EV_File.h"
#endif

/*==================================================================
  ㏸~\\
==================================================================*/
struct Position
{
	int m_UNSL;
	int m_UNST;
	int m_UPSL;
	int m_UPST;
	/* ~ʒu */
	int *p_UnderSlow;
	/* ~~ʒu */
	int *p_UnderStop;
	/* ㏸ʒu */
	int *p_UpperSlow;
	/* ㏸~ʒu */
	int *p_UpperStop;
	/* Sleepp */
	int fstop;
	int *p_fstop;
	int fmove;
	int *p_fmove;
};

/* ㏸ */
struct UpMotor
{
	struct EV_File SF;
	struct EV_File MF;
};

/* ~ */
struct DownMotor
{
	struct EV_File SF;
	struct EV_File MF;
};

/* Gx[^[̈ʒuzO */
struct WaitPositionChangeLog
{
	struct EV_File LF;
	char strLimit[9];
	char *p_strLimit;
	/* Sleepp */
	int tmp;
};

/*==================================================================
  ㏸~\vg^Cv錾
==================================================================*/
void Position(struct Position *This);
/* ㏸ */
void UpMotor(struct UpMotor *This);
void OnUpMotor(struct UpMotor *This, struct Position *P, char *p_Safety);
/* ~ */
void DownMotor(struct DownMotor *This);
void OnDownMotor(struct DownMotor *This, struct Position *P, char *p_Safety);
/* oߎ */
void WaitPositionChangeLog(struct WaitPositionChangeLog *This);
void OnInitWaitPositionChangeLog(struct WaitPositionChangeLog *This, struct Position *P);
void OnWaitUpPositionChangeLog(struct WaitPositionChangeLog *This, struct Position *P);
void OnWaitDownPositionChangeLog(struct WaitPositionChangeLog *This, struct Position *P);
/* ㏸ */
void Up(struct Position *P, struct UpMotor UPMT, struct WaitPositionChangeLog WPCL, char *p_Safety);
/* ~ */
void Down(struct Position *P, struct DownMotor DNMT, struct WaitPositionChangeLog WPCL, char *p_Safety);
