/* main.c */

#include "C.h"
#include "main.h"

#ifdef USE_THREAD
Count Cnt;
int i_cnt, j_cnt;
#ifndef USE_BCC
/* [Xbh̋[CX^X錾 */
Thread* th[2];
#else
/* [Xbh̋[CX^X錾 */
Thread* th[8];
#endif
/* ^Xbh̋^CX^X錾 */
Thread *th1[4];
Thread *th19;
Thread *th20;
Thread *th41;
Thread *th42;
Thread *th43;
Thread *th44;
Thread *th45;
#endif
#ifdef NOTUSE_FILES
EV_Status s;
#endif

/*==================================================================
  ̓IuWFNg錾
==================================================================*/
struct EV_Input in;

/*==================================================================
  IuWFNg錾
==================================================================*/
struct EV_Controller cntrl;

/*==================================================================
  MIuWFNg錾
==================================================================*/
struct EV_Puls puls;

/*==================================================================
  V~[^IuWFNg錾
==================================================================*/
struct EV_Simulator simu;

#ifdef USE_LINUX
/*==================================================================
  L^IuWFNg錾
==================================================================*/
struct EV_Log lg;
#endif

int main(void)
{
#ifndef USE_BCC
	char sw[4];
	int i;
	int j;
	int f;
	int cnt;
	static char buff[64];
#endif
#ifdef USE_THREAD
	Thread *th30;
	Thread *th31;
#endif
#ifndef USE_BCC
	for(i=0;i<0x7fff;i++) {}
	H8init(); /* H8 WX^ */
	InitSCI(); /* SCI1(serial) */
	InitLCD(); /* LCD */
	
	/* LED OFF */
	SetLED(0,0);
	SetLED(1,0);
	SetLED(2,0);
	SetLED(3,0);
	
	/*--------------------------------------------------*/
	/* USB */
	InitUSB();
	INTC.ISCR &= (-1^0x20);	 /* IRQ_5 ݽ۰ Active Low */
	INTC.IER |= 0x20; /* IRQ5 Enable */
	/*--------------------------------------------------*/
	EnableInterrupt(); /* 荞݋ ccr */
	
	f = 0;
	PrintSCI("CPU MODE %02X\n",MDCR); /* MODE 6 */
	PrintLCD("\fReady!3052"); /* '\f'LCDNAɗp */
	
	/* XCb`[N */
	sw[0] = sw[1] = sw[2] = sw[3] = 0;
#else
	printf("\nHello BCC");
#endif
#ifdef NOTUSE_FILES
	/* t@C */
	new_EV_Status(&s);
#endif
#ifdef USE_THREAD
	/* ^C}[ */
	initWOVI();
	/* 2bҋ@ */
	SleepMSec(2000);
	/* LEDTEST */
	th30 = new_Thread(30);
	th31 = new_Thread(31);
	Start(th30);
	Start(th31);
	for(;;)
	{
		/* ^C}[Ăяo */
#ifdef USE_CENTOS
		wovi(15000000.0);
#else
#ifdef USE_RASPBIAN
		wovi(2500000.0);
#else
		wovi();
#endif
#endif
		if(Thread_checkAllDelete() == OK)
		{
			break;
		}
	}
#endif
	Clear();
	PrintF(Panel, "NEXT            ");
	/* 2bҋ@ */
	SleepMSec(2000);
	Clear();
#ifndef USE_BCC
	for(;;)
	{
		/*--------------------------------------------------*/
		/* {^ꂽLCD,SCI,USBɃbZ[W𑗂 */
		for(j=0;j<4;j++)
		{
			i = GetSW(j);
			if( ((sw[j]^1) & i) ) /* sw = off->onŏ */
			{
				SetLED(j,1); /* LEDuԓ_ */
				sprintf(buff,"sw%u",j+1);
				PrintSCI("%s\n",buff);
				/* NULL(0x00)܂őM */
				write_buff(buff,strlen(buff)+1);
				PrintLCD(buff);
			}
			else SetLED(j,0);
			sw[j] = i;
		}
		
		/*--------------------------------------------------*/
		/* HOST̃VA͂LCD,USBɑ */
		if(ScanSCI()) /* SCIɎMf[^? */
		{
			i = GetSCI(); /* VA */
			PutLCD(i); /* LCDo */
			buff[0] = i;
			write_buff(buff,1); /* USBo */
		}
		
		/*--------------------------------------------------*/
		/* USBf[^MꍇÂ܂HOSTփ_CNg  */
		if(get_inbufflen()) /* Mf[^? */
		{
			/* f[^擾(buffTCY64byte܂) */
			cnt = read_buff(buff,64);
			PrintLCD("\f"); /* LCDNA */
			PrintLCD(buff); /* LCD֕\ */
			PrintSCI(buff); /* VAo */
			write_buff(buff,cnt); /* USBփ_CNg */
		}
		
		/*--------------------------------------------------*/
		/* mF̂ߓ_ */
		SetLED(3,f);
		f ^= 1;
		for(i=0;i<10000;i++) {} /* KɃEGCg */
	}
#else
	printf("END");
	/* 5bҋ@ */
	SleepMSec(5000);
	return OK;
#endif
}

#ifdef USE_THREAD
/*
 * [Xbh̋[\bh֐
 */
 /* public void paint(Graphics g)̑p */
void Repaint(void)
{
#ifndef USE_BCC
	int i;
#else
	int i,j;
#endif
	Clear();
#ifndef USE_BCC
	for(i = 0; i < Cnt.cnt[0]; i++)
	{
		PrintF(Panel, " ");
	}
	PrintF(Panel, "<1>");
	PrintF(Panel, "\n");
	for(i = 0; i < Cnt.cnt[1]; i++)
	{
		PrintF(Panel, " ");
	}
	PrintF(Panel, "<2>");
#else
	for(i = 0; i < 8; i++)
	{
		for(j = 0; j < Cnt.cnt[i]; j++)
		{
			printf(" ");
		}
		printf("<%d>", (i + 1));    
		for(j = 0; j < 13 - Cnt.cnt[i]; j++)
		{
			printf(" ");
		}
		printf("|");
		printf("\n");
	}
#endif
	return;
}

/*
 * ^Xbh̋^\bh֐
 */
/* Xbhpublic void run()̑p */
void Run(Thread *This)
{
	int i;
	Thread *th11;
#ifdef USE_BCC
	char key = '\0';
#else
	int j;
	char sw[4];
	/* XCb`[N */
	sw[0] = sw[1] = sw[2] = sw[3] = 0;
#endif
	if(This->ID == 1)
	{
		Repaint();
#ifndef USE_BCC
		Cnt.cnt[0]++;
		nextRun(This, (((rand() % 9) + 10) * 100));
#else
		if(kbhit())
		{
#ifdef USE_LINUX
			key = (char) getchar();
#else
			key = (char) getche();
#endif
		}
		if(key == 'r')
		{
			Cnt.cnt[0]++;
		}
		nextRun(This, (((rand() % 9) + 10) * 15));
		while(kbhit())
		{
#ifdef USE_LINUX
			key = (char) getchar();
#else
			key = (char) getche();
#endif
		}
#endif
	}
	else if(This->ID == 2)
	{
		Repaint();
#ifndef USE_BCC
		Cnt.cnt[1]++;
		nextRun(This, (((rand() % 9) + 10) * 100));
#else
		if(kbhit())
		{
#ifdef USE_LINUX
			key = (char) getchar();
#else
			key = (char) getche();
#endif
		}
		if(key == 'l')
		{
			Cnt.cnt[1]++;
		}
		nextRun(This, (((rand() % 9) + 10) * 15));
		while(kbhit())
		{
#ifdef USE_LINUX
			key = (char) getchar();
#else
			key = (char) getche();
#endif
		}
#endif
	}
#ifdef USE_BCC
	else if(((This->ID) >= 3) && ((This->ID) <= 8))
	{
			Repaint();
			Cnt.cnt[(This->ID) - 1]++;
			nextRun(This, (((rand() % 9) + 10) * 40));
	}
#endif
	else if(This->ID == 11)
	{
		if(This->count == 1)
		{
			Clear();
			PrintF(Panel, "<1>1st          ");
			countUpNextRun(This, (1900 * 1));
		}
		else if(This->count == 2)
		{
			Clear();
			PrintF(Panel, "<1>2nd");
			PrintF(Panel, "<1>Stop   ");
			Stop(This);
		}
		else if(This->count == 3)
		{
			Clear();
			PrintF(Panel, "<1>3rd          ");
			countUpNextRun(This, (1500 * 1));
		}
		else if(This->count == 4)
		{
			Clear();
			PrintF(Panel, "<1>Stop         ");
			Stop(This);
		}
	}
	else if(This->ID == 12)
	{
		if(This->count == 1)
		{
			Clear();
			PrintF(Panel, "<2>1st          ");
			countUpNextRun(This, (1700 * 2));
		}
		else if(This->count == 2)
		{
			Clear();
			PrintF(Panel, "<2>2nd          ");
			countUpNextRun(This, (1700 * 2));
		}
		else if(This->count == 3)
		{
			Clear();
			PrintF(Panel, "<2>3rd          ");
			countUpNextRun(This, (1700 * 2));
		}
		else
		{
			Clear();
			PrintF(Panel, "<2>Stop");
			Stop(This);
			delete_(This);
		}
	}
	else if(This->ID == 13)
	{
		if(This->count == 1)
		{
			Clear();
			PrintF(Panel, "<3>1st          ");
			countUpNextRun(This, (1700 * 3));
		}
		else if(This->count == 2)
		{
			Clear();
			PrintF(Panel, "<3>2nd          ");
			countUpNextRun(This, (1700 * 3));
		}
		else if(This->count == 3)
		{
			Clear();
			PrintF(Panel, "<3>3rd          ");
			countUpNextRun(This, (1700 * 3));
		}
		else
		{
			Clear();
			PrintF(Panel, "<3>Stop");
			Stop(This);
			delete_(This);
		}
	}
	else if(This->ID == 14)
	{
		if(This->count == 1)
		{
			Clear();
			PrintF(Panel, "<4>1st          ");
			countUpNextRun(This, (1500 * 4));
		}
		else if(This->count == 2)
		{
			Clear();
			PrintF(Panel, "<4>2nd");
			countUpNextRun(This, (1500 * 4));
			
			PrintF(Panel, "<1>Start  ");
			th11 = Thread_Start(11);
			countUpNextRun(th11, (1500 * 1));
		}
		else if(This->count == 3)
		{
			Clear();
			PrintF(Panel, "<4>3rd          ");
			countUpNextRun(This, (1500 * 4));
		}
		else if(This->count == 4)
		{
			th11 = Thread_getThread(11);
			if(th11 != NULL)
			{
				delete_(th11);
			}
			
			PrintF(Panel, "<4>Sto");
			Stop(This);
			delete_(This);
		}
	}
	else if(This->ID == 19)
	{
#ifdef USE_LINUX
		nextRun(This, 4000);
#else
		nextRun(This, 1);
#endif
#ifndef USE_BCC
		/* {^ꂽLCD,SCI,USBɃbZ[W𑗂 */
		for(j=0;j<4;j++)
		{
			i = GetSW(j);
			if( ((sw[j]^1) & i) ) /* sw = off->onŏ */
			{
				Thread_Toggle(j + 20);
				nextRun(This, 1000);
			}
		}
#else
		key = '\0';
		key = GetChar(key);
		
		if(key == '1')
		{
			Thread_Toggle(21);
		}
		else if(key == '2')
		{
			Thread_Toggle(22);
		}
		else if(key == '3')
		{
			Thread_Toggle(23);
		}
		else if(key == '4')
		{
			Thread_Toggle(24);
		}
		else if(key == '5')
		{
			Thread_Toggle(25);
		}
		else if(key == '6')
		{
			Thread_Toggle(26);
		}
		else if(key == '7')
		{
			Thread_Toggle(27);
		}
		else if(key == '8')
		{
			Thread_Toggle(28);
		}
		else if(key == '9')
		{
			Thread_Toggle(29);
		}
		else if(key == '0')
		{
			Thread_Toggle(20);
		}
#endif
	}
	else if(This->ID == 20)
	{
		PrintF(Panel, "0");
		countUpNextRun(This, 2000);
	}
	else if(This->ID == 21)
	{
		PrintF(Panel, "1");
		countUpNextRun(This, 2000);
	}
	else if(This->ID == 22)
	{
		PrintF(Panel, "2");
		countUpNextRun(This, 2000);
	}
	else if(This->ID == 23)
	{
		PrintF(Panel, "3");
		countUpNextRun(This, 2000);
	}
#ifdef USE_BCC
	else if((This->ID >= 24) && (This->ID <= 29))
	{
		printf("%d", This->ID - 20);
		nextRun(This, 2000);
	}
#endif
#ifndef USE_BCC
	else if(This->ID == 30)
	{
		if(This->count == 0)
		{
			This->count++;
			PB.DR &= 0x0e;
			nextRun(This, 1000);
		}
		else if(This->count == 1)
		{
			This->count--;
			PB.DR |= 0x01;
			nextRun(This, 1000);
		}
	}
#endif
	else if(This->ID == 31)
	{
		if(This->count == 0)
		{
			/* 1 */
#ifdef USE_BCC
			printf("\nThread Ready GO! There are 8 cources on a race.");
			printf("\nThere are 14 cells to a GOAL.");
			printf("\nFor the <1> cource, You click a 'R' button.");
			printf("\nFor the <2> cource, You click a 'L' button.");
#endif
#ifndef USE_BCC
			countUpNextRun(This, 0);
#else
			/* 5bҋ@ */
			countUpNextRun(This, 5000);
#endif
		}
		else if(This->count == 1)
		{
			/* [XbhJn */
			PrintF(Panel, "\n");
			PrintF(Panel, "Thread Ready GO!");
			/* 2bҋ@ */
			countUpNextRun(This, 2000);
		}
		else if(This->count == 2)
		{
#ifndef USE_BCC
			/* [Xbh̋[CX^X */
			for(i = 0; i < 2; i++)
			{
				th[i] = new_Thread(i + 1);
			}
#else
			/* [Xbh̋[CX^X */
			for(i = 0; i < 8; i++)
			{
				th[i] = new_Thread(i + 1);
			}
#endif
			countUpNextRun(This, 1);
		}
		else if(This->count == 3)
		{
#ifndef USE_BCC
			if(Cnt.cnt[0] >= 13)
			{
				i_cnt = 1;
				This->count++;
			}
			else if(Cnt.cnt[1] >= 13)
			{
				i_cnt = 2;
				This->count++;
			}
#else
			i_cnt = Cnt.cnt[0];
			j_cnt = 0;
			for(i = 1; i < 8; i++)
			{
				if(i_cnt < Cnt.cnt[i])
				{
					i_cnt = Cnt.cnt[i];
					j_cnt = i;
				}
			}
			if(i_cnt >= 13) This->count++;
#endif
			nextRun(This, 1);
		}
		else if(This->count == 4)
		{
			Clear();
			if(i_cnt == 1)
			{
				PrintF(Panel, "GOAL!<1>WON     ");
			}
			else if(i_cnt == 2)
			{
				PrintF(Panel, "GOAL!<2>WON     ");
			}
#ifdef USE_BCC
			else
			{
				printf("GOAL!\n<%d>WON", (j_cnt + 1));
			}
#endif
#ifndef USE_BCC
			delete_(th[0]);
			delete_(th[1]);
#else
			for(i = 0; i < 8; i++)
			{
				delete_(th[i]);
			}
#endif
#ifdef USE_LINUX
			This->count = 15;
#else
			This->count++;
#endif
			/* 2bҋ@ */
			nextRun(This, 2000);
		}
		else if(This->count == 5)
		{
			Clear();
			PrintF(Panel, "NEXT            ");
			/* 2bҋ@ */
			countUpNextRun(This, 2000);
		}
		else if(This->count == 6)
		{
			Clear();
			/* 2 */
			PrintF(Panel, "CountUp         ");
			/* 2bҋ@ */
			countUpNextRun(This, 2000);
		}
		else if(This->count == 7)
		{
			/* ^XbhJn */
			Clear();
			/* ^Xbh̋^CX^X */
			for(i = 0; i < 4; i++)
			{
				th1[i] = new_Thread(i + 11);
			}
			countUpNextRun(This, 1);
		}
		else if(This->count == 8)
		{
			if(Thread_checkStayAnother() == 2)
			{
				This->count++;
			}
			nextRun(This, 1);
		}
		else if(This->count == 9)
		{
			/* 2bҋ@ */
			countUpNextRun(This, 2000);
		}
		else if(This->count == 10)
		{
			Clear();
			PrintF(Panel, "NEXT            ");
			/* 2bҋ@ */
			countUpNextRun(This, 2000);
		}
		else if(This->count == 11)
		{
			Clear();
			/* 3 */
			PrintF(Panel, "Toggle          ");
			/* 2bҋ@ */
			countUpNextRun(This, 2000);
		}
		else if(This->count == 12)
		{
			th19 = new_Thread(19);
			Start(th19);
			th20 = new_Thread(20);
			Start(th20);
			countUpNextRun(This, 1);
		}
		else if(This->count == 13)
		{
			if(Thread_checkStayAnother() == 3)
			{
				delete_(th19);
				This->count++;
			}
			nextRun(This, 1);
		}
		else if(This->count == 14)
		{
			countUpNextRun(This, 2000);
		}
		else if(This->count == 15)
		{
			Clear();
			PrintF(Panel, "NEXT            ");
			/* 2bҋ@ */
			countUpNextRun(This, 2000);
		}
		else if(This->count == 16)
		{
			Clear();
			/* 4 */
			PrintF(Panel, "Hello EV        ");
			/* 2bҋ@ */
			countUpNextRun(This, 2000);
		}
		else if(This->count == 17)
		{
			/* [Xbh̋[CX^X */
			th41 = new_Thread(41);
			th42 = new_Thread(42);
			th43 = new_Thread(43);
			th44 = new_Thread(44);
#ifdef USE_LINUX
			th45 = new_Thread(45);
#endif
			
			delete_(This);
			
			/* LEDTEST */
			delete_(Thread_getThread(30));
		}
	}
	else if(This->ID == 41)
	{
		nextRun(This, 100);
		OnInput(&in, This);
	}
	else if(This->ID == 42)
	{
		nextRun(This, 100);
		OnController(&cntrl, This);
	}
	else if(This->ID == 43)
	{
		nextRun(This, 110);
		OnPuls(&puls, This);
	}
	else if(This->ID == 44)
	{
		nextRun(This, 2000);
		OnSimulator(&simu, This);
	}
#ifdef USE_LINUX
	else if(This->ID == 45)
	{
		nextRun(This, 2000);
		OnLog(&lg, This);
	}
#endif
	return;
}

/* Xbh̃RXgN^public void init()̑p */
void Init(Thread *This)
{
	if(This->ID == 1)
	{
		Cnt.cnt[0] = 0;
		nextRun(This, (((rand() % 9) + 10) * 30));
	}
	else if(This->ID == 2)
	{
		Cnt.cnt[1] = 0;
		nextRun(This, (((rand() % 9) + 10) * 30));
	}
	else if((This->ID >= 3) && (This->ID <= 8))
	{
		Cnt.cnt[(This->ID) - 1] = 0;
		nextRun(This, (((rand() % 9) + 10) * 200));
	}
	else if(This->ID == 11)
	{
		PrintF(Panel, "<1>Init");
		countUpNextRun(This, (1500 * 1));
	}
	else if(This->ID == 12)
	{
		PrintF(Panel, "<2>Init  ");
		countUpNextRun(This, (1500 * 2));
	}
	else if(This->ID == 13)
	{
		PrintF(Panel, "\n");
		PrintF(Panel, "<3>Init");
		countUpNextRun(This, (1500 * 3));
	}
	else if(This->ID == 14)
	{
		PrintF(Panel, "<4>Init  ");
		countUpNextRun(This, (1500 * 4));
	}
	else if(This->ID == 20)
	{
		Clear();
		PrintF(Panel, "<0>Init         ");
		PrintF(Panel, "\n");
		countUpNextRun(This, 2000);
	}
	else if(This->ID == 21)
	{
		Clear();
		PrintF(Panel, "<1>Init         ");
		PrintF(Panel, "\n");
		countUpNextRun(This, 2000);
	}
	else if(This->ID == 22)
	{
		Clear();
		PrintF(Panel, "<2>Init         ");
		PrintF(Panel, "\n");
		countUpNextRun(This, 2000);
	}
	else if(This->ID == 23)
	{
		Clear();
		PrintF(Panel, "<3>Init         ");
		PrintF(Panel, "\n");
		countUpNextRun(This, 2000);
	}
#ifdef USE_BCC
	else if((This->ID >= 24) && (This->ID <= 29))
	{
		printf("\n<%d>Init\n", This->ID - 20);
		nextRun(This,2000);
	}
#endif
#ifndef USE_BCC
	else if(This->ID == 30)
	{
		PB.DDR = 0xff; /* bit7..0 out */
		PB.DR |= 0xff;
	}
#endif
	else if(This->ID == 41)
	{
		nextRun(This, 100);
		EV_Input(&in);
	}
	else if(This->ID == 42)
	{
		nextRun(This, 100);
		EV_Controller(&cntrl, This);
	}
	else if(This->ID == 43)
	{
		nextRun(This, 110);
		EV_Puls(&puls, This);
	}
	else if(This->ID == 44)
	{
		nextRun(This, 2000);
		EV_Simulator(&simu, This);
	}
#ifdef USE_LINUX
	else if(This->ID == 45)
	{
		nextRun(This,1);
		EV_Log(&lg);
	}
#endif
	return;
}

/* Xbh̃fXgN^̑p */
void Destroy(Thread *This)
{
	if(This->ID == 11)
	{
		Clear();
		PrintF(Panel, "<1>Destroy");
	}
	else if(This->ID == 12)
	{
		PrintF(Panel, "<2>Destro");
	}
	else if(This->ID == 13)
	{
		PrintF(Panel, "<3>Destro");
	}
	else if(This->ID == 14)
	{
		PrintF(Panel, "\n");
		PrintF(Panel, "<4>Destroy      ");
	}
	if(This->ID == 20)
	{
		Clear();
		PrintF(Panel, "<0>Destroy      ");
		PrintF(Panel, "\n");
	}
	else if(This->ID == 21)
	{
		Clear();
		PrintF(Panel, "<1>Destroy      ");
		PrintF(Panel, "\n");
	}
	else if(This->ID == 22)
	{
		Clear();
		PrintF(Panel, "<2>Destroy       ");
		PrintF(Panel, "\n");
	}
	else if(This->ID == 23)
	{
		Clear();
		PrintF(Panel, "<3>Destroy       ");
		PrintF(Panel, "\n");
	}
#ifdef USE_BCC
	else if((This->ID >= 24) && (This->ID <= 29))
	{
		printf("\n<%d>Destroy\n", This->ID - 20);
	}
#endif
#ifdef USE_LINUX
	else if(This->ID == 45)
	{
		delete_EV_Log(&lg);
	}
#endif
	return;
}
#endif

#ifndef USE_BCC
/*==================================================================
							LEDRg[							
--------------------------------------------------------------------
	int SetLED(int no,int onoff)									
																	
	int		no			LEDio[ 0`3							
	int		onoff		0=OFF,1=ON									
	߂l				ȑOLED̏	(0=OFF,else=ON)				
																	
	LEDRg[܂B										
==================================================================*/
int SetLED(int no,int onoff)
{
	int f;
	f = PB.DR&(1<<no);
	if( onoff == 0 ) PB.DR |= (1<<no); /* off (1) */
	else PB.DR &= 0xff^(1<<no); /* on (0) */
	return( f );
}

/*==================================================================
								SWԎ擾							
--------------------------------------------------------------------
	int GetSW(int no)												
																	
	int		no			SWio[ 0`3								
	߂l				SW̏(0=OFF,else=ON)						
																	
	SW̏Ԃ擾܂B											
==================================================================*/
int GetSW(int no)
{
	return( ((PA.DR&(1<<no))?0:1) );
}

/*==================================================================
								H8							
--------------------------------------------------------------------
	BUS[hA|[g̏										
																	
	P1	bit1	BUS		USB A0										
	P3			BUS		USB D7..0									
	P6 bit4		BUS		USB RD										
	P6 bit5		BUS		USB WR										
	P8 bit2		BUS		USB CS										
	P9 bit5		BUS		USB INT(IRQ5)								
	P9 bit3		BUS		RS232C										
	P9 bit1		BUS		RS232C										
																	
	PA bit0..3	IN		SW0..3										
	PB bit0..3	OUT		LED0..3  LCD DB4..7							
	PB bit4		OUT		         LCD RS								
	PB bit7		OUT		         LCD E								
==================================================================*/
void H8init()
{
	BSC.ABWCR = 0x06; /* 8bit BUS MODE */

	P1.DDR = 0xff; /* all OUT */
	P2.DDR = 0xff; /* all OUT */
	P2.PCR = 0x00; /* Pull up off */
	P5.DDR = 0xff; /* all OUT */
	P5.PCR = 0x00; /* Pull up off */
	P6.DDR = 0xff; /* all OUT */
	P9.DDR = 0xdf; /* Bit5 IN */
	P8.DDR = 0xff; /* all OUT */
	PA.DDR = 0xf0; /* bit7..4 out , bit3..0 in */
	PB.DDR = 0xff; /* bit7..0 out */
}
#endif
